#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;
#define int long long

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    int n, k; cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int ans = 0;
    multiset<int> st;
    int mx = 0;\
    for (int i = 0; i < k - 1; i++) {
    st.insert(a[i]); mx += a[i];
}
    for (int i = k - 1; i < n; i++) {
        ans = max(mx + (i + 1) + a[i], ans);
        if (!st.empty() && a[i] > *st.begin()) {
            mx -= *st.begin();
            st.erase(st.begin());
            mx += a[i];
            st.insert(a[i]);
        }
    }
    cout << ans;
    return 0;
}
